#-------------------------------------------------------------------------------------------------#
#                                                                                                 #
#-------------------------------------------------------------------------------------------------#

__all__ = ['annotate']

from inspect import getargspec

def annotate(*args, **kwargs):

    """ Decorator to set a function's __annotations__ like Py3 """

    def decorate(func):
        try:
            func.__annotations__
        except AttributeError:
            argspec = getargspec(func)
            func.__annotations__ = dict(zip(argspec.args, args), **kwargs)
            if "returns" in kwargs:
                func.__annotations__["return"] = func.__annotations__.pop("returns")
        return func

    return decorate

#---------------------------------------------  EOF  ---------------------------------------------#
